<?php

namespace Drupal\web_push\Plugin\QueueWorker;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Queue\QueueWorkerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Send push notification to subscription.
 *
 * @QueueWorker(
 *   id = "web_push",
 *   title = @Translation("Send Push Notifications"),
 * )
 */
class WebPushQueueWorker extends QueueWorkerBase implements ContainerFactoryPluginInterface {

  protected $sender;

  public function __construct(array $configuration, $plugin_id, $plugin_definition, $sender) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->sender = $sender;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(
    ContainerInterface $container,
    array $configuration,
    $plugin_id,
    $plugin_definition
  ) {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $container->get('web_push.sender')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function processItem($pushData) {
    $this->sender->sendNotification($pushData);
  }
}